unit FelhAdatok;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.StrUtils, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Vcl.WinXPickers;

type
  TForm2 = class(TForm)
    EditNev: TEdit;
    EditEmail: TEdit;
    EditCim: TEdit;
    LabelNev: TLabel;
    LabelEmail: TLabel;
    LabelSzulDat: TLabel;
    LabelCim: TLabel;
    LabelIrsz: TLabel;
    EditIrsz: TEdit;
    ButtonSaveProfile: TButton;
    LabelNevError: TLabel;
    LabelEmailError: TLabel;
    LabelCimError: TLabel;
    LabelIrszError: TLabel;
    DatePickerSzulDat: TDatePicker;
    LabelSzulDatError: TLabel;
    LabelKitoltendo: TLabel;

    procedure OnShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormOnResize(Sender: TObject);
    procedure SetButtonsLabelsTexts();
    procedure ButtonSaveProfileClick(Sender: TObject);
    procedure EditNevChange(Sender: TObject);
    procedure EditEmailChange(Sender: TObject);
    procedure DatePickerSzulDatChange(Sender: TObject);
    procedure EditCimChange(Sender: TObject);
    procedure EditIrszChange(Sender: TObject);
    function CheckValues() : Bool;


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation
{$R *.dfm}
uses RajzProgram, RajzMentese;

// OnShow
procedure TForm2.OnShow(Sender: TObject);
begin
  Screen.Cursor := crDefault;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin

  Screen.Cursor := crDefault;
  Constraints.MinHeight := Form2.Height;
  Constraints.MinWidth := Form2.Width; Constraints.MaxWidth := Form2.Width;
  SetButtonsLabelsTexts();

  LabelSzulDatError.Caption := 'Grgesse ki a szletsi dtumt.' + #13#10 + 'Majd nyomja meg a pipt.';
  // A Delphi 11 -ben mg nem lehet jobb egrgombbal Quick Edit.. -el megoldani az ENTER (#13#10) karakter
end;

// RESIZE
procedure TForm2.FormOnResize(Sender: TObject);
begin
  SetButtonsLabelsTexts();
end;

procedure TForm2.SetButtonsLabelsTexts();
begin
  ButtonSaveProfile.Top := Form2.Height - ButtonSaveProfile.Height - 60;
  LabelKitoltendo.Top := ButtonSaveProfile.Top + Round(ButtonSaveProfile.Height/2);
end;

procedure TForm2.ButtonSaveProfileClick(Sender: TObject);
begin

  if CheckValues() (* a funkci a fjl aljn tallhat *) then
  begin

    Form1.customer.nev := EditNev.Text;
    Form1.customer.email := EditEmail.Text;
    Form1.customer.szuldat := DateToStr(DatePickerSzulDat.Date);
    Form1.customer.cim  := EditCim.Text;
    Form1.customer.irsz := StrToInt(EditIrsz.Text);

    Form1.SavePicToFile('FelhAdatok.txt');
    ShowMessage('A kvetkez felhasznli adatokat a program mentette:' + #13#10#13#10 +
                  Form1.felh_adatok );

    Form1.ButtonFelhAdatok.Caption := 'Felhasznli Adatok Mdostsa';
    Form2.Close();

  end;

end;

procedure TForm2.EditNevChange(Sender: TObject);
begin
  CheckValues();
end;

procedure TForm2.EditEmailChange(Sender: TObject);
begin
  CheckValues();
end;

procedure TForm2.DatePickerSzulDatChange(Sender: TObject);
begin
  LabelSzulDatError.Caption := '';
end;

procedure TForm2.EditCimChange(Sender: TObject);
begin
  CheckValues();
end;

procedure TForm2.EditIrszChange(Sender: TObject);
begin
  CheckValues();
end;

function TForm2.CheckValues() : Bool;
var
  jo: boolean;
  int: integer;
begin

  jo :=True;

  //nv helyes-e ?
  for int := 0 to 9 do // a nv tartalmaz-e szmot ?
    if ContainsStr( EditNev.Text, IntToStr(int) ) then
      jo := false;
  if not jo or not ContainsStr(EditNev.Text,' ') then //van-e benne space ?
    begin
      jo := False;
      LabelNevError.Caption := 'Teljes nevet hasznljon!' + #13#10 + 'Szmot nem tartalmazhat.';
    end
  else
    LabelNevError.Caption := '';

  //e-mail cm helyes-e ?
  if not ContainsStr( EditEmail.Text, '@' ) or not ContainsStr( EditEmail.Text, '.' ) then
    begin
      jo := False;
      LabelEmailError.Caption := 'Nem megfelel e-mail formtum.';
    end
  else
    LabelEmailError.Caption := '';

  //lakcm helyes-e ?
  if not ContainsStr( EditCim.Text, '0' ) and
     not ContainsStr( EditCim.Text, '1' ) and
     not ContainsStr( EditCim.Text, '2' ) and
     not ContainsStr( EditCim.Text, '3' ) and
     not ContainsStr( EditCim.Text, '4' ) and
     not ContainsStr( EditCim.Text, '5' ) and
     not ContainsStr( EditCim.Text, '6' ) and
     not ContainsStr( EditCim.Text, '7' ) and
     not ContainsStr( EditCim.Text, '8' ) and
     not ContainsStr( EditCim.Text, '9' ) or
     not ContainsStr( EditCim.Text, ' ' ) then
    begin
      jo := False;
      LabelCimError.Caption := 'Szmot nem tartalmaz vagy tl rvid.';
    end
      else
      LabelCimError.Caption := '';

  //Irnytszm helyes-e ?
  if not TryStrToInt(EditIrsz.Text, int) then
    begin
      jo := False;
      EditIrsz.Text  := '';     // default value
      LabelIrszError.Caption := 'Csak szmjegyeket hasznlhat.';
    end
  else
    LabelIrszError.Caption := '';

  if jo = False then
    begin
      CheckValues := False;
      ButtonSaveProfile.Enabled := False;
      LabelKitoltendo.Enabled := True;
    end
  else
    begin
      CheckValues := True;
      ButtonSaveProfile.Enabled := True;
      LabelKitoltendo.Enabled := False;
    end;

end;

end.
