unit RajzBetoltese;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.FileCtrl;

type
  TForm4 = class(TForm)
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    ButtonLoad: TButton;
    ButtonExit: TButton;
    LabelSelectedFolderFile: TLabel;
    LabelSelectedFile: TLabel;
    procedure OnShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormOnResize(Sender: TObject);
    procedure SetButtonsLabelsTexts();
    procedure ButtonLoadClick(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
    procedure DriveComboBox1Change(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    LoadFileName : String;
    LoadFolderAndFileName : String;
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation
{$R *.dfm}
uses RajzProgram;

// OnShow
procedure TForm4.OnShow(Sender: TObject);
begin
  Screen.Cursor := crDefault;
  FileListBox1.Update;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  Screen.Cursor := crDefault;
  Width := 1000; Height := 600;
  Constraints.MinWidth := 600;
  Constraints.MinHeight := 300;
  SetButtonsLabelsTexts();

  FileListBox1.Update;
  FileListBox1.Mask := '*.txt';
end;

// RESIZE
procedure TForm4.FormOnResize(Sender: TObject);
begin
  SetButtonsLabelsTexts();
end;

procedure TForm4.SetButtonsLabelsTexts();
begin
  FileListBox1.Left := Form4.Width - FileListBox1.Width - 40;
  ButtonExit.Left := DirectoryListBox1.Left;
  ButtonLoad.Left := DirectoryListBox1.Left + DirectoryListBox1.Width - ButtonLoad.Width;
  LabelSelectedFile.Left := ButtonLoad.Left;

  ButtonExit.Top := Form4.Height - ButtonExit.Height - 60;
  LabelSelectedFile.Top := Form4.Height - 60;
  ButtonLoad.Top := Form4.Height - ButtonLoad.Height - 60;

  FileListBox1.Height := FileListBox1.Top + (ButtonExit.Top - FileListBox1.Top) - 60;
  DirectoryListBox1.Height := DirectoryListBox1.Top + (ButtonExit.Top - DirectoryListBox1.Top) - 60;
  DirectoryListBox1.Width := FileListBox1.Left - 50;
end;

procedure TForm4.ButtonLoadClick(Sender: TObject);
begin
  Form1.Rajz_Betolt(LoadFolderAndFileName);
  Form4.Close();
end;

procedure TForm4.DriveComboBox1Change(Sender: TObject);
begin
  DirectoryListBox1.Drive := DriveComboBox1.Drive;
end;

procedure TForm4.DirectoryListBox1Change(Sender: TObject);
begin
  FileListBox1.Directory := DirectoryListBox1.Directory;
end;

procedure TForm4.FileListBox1Change(Sender: TObject);
var
  List : TStrings;
begin

  LoadFolderAndFileName := FileListBox1.FileName;
  LabelSelectedFolderFile.Caption := LoadFolderAndFileName;

  List := TStringList.Create;
  ExtractStrings(['\'], [], PChar(LoadFolderAndFileName), List);
  if(0 < List.Count) then
  begin
    LabelSelectedFile.Caption := List[List.Count - 1] + ' betltse.';
    LoadFileName := List[List.Count - 1];
  end;
  List.Free;

end;

// 'Mgse' gomb
procedure TForm4.ButtonExitClick(Sender: TObject);
begin
  Form4.Close();
end;

//Form Bezrsnl rfrisst a fjl listra
procedure TForm4.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FileListBox1.Update;
end;

end.
