unit RajzProgram;

interface

uses
  Winapi.Windows, Winapi.Messages, Winapi.ShellAPI,
  System.StrUtils, System.SysUtils, System.Variants, System.Classes,
  Math,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Vcl.ActnMan, Vcl.ActnColorMaps, VCLTee.TeCanvas, Vcl.ColorGrd, Vcl.TitleBarCtrls, Vcl.Menus;

type
    TForm1 = class(TForm)
    ButtonVonal: TButton;
    ButtonTeglalap: TButton;
    ButtonKor: TButton;
    ButtonRombusz: TButton;
    EditLineWidth: TEdit;
    ButtonSave: TButton;
    ButtonLoad: TButton;
    ButtonFelhAdatok: TButton;
    LabelLineWidth: TLabel;
    ButtonColor: TButtonColor;
    ButtonKepTorles: TButton;
    TitleBarPanel1: TTitleBarPanel;
    ButtonVisszaRajzol: TButton;
    PopupMenu1: TPopupMenu;
    procedure FormCreate(Sender: TObject);
    procedure PopupItemSetColorWidthClick(Sender: TObject);
    procedure PopupItemDeleteClick(Sender: TObject);
    procedure FormOnResize(Sender: TObject);
    procedure SetButtonsLabelsTexts();
    procedure ButtonFelhAdatokClick(Sender: TObject);
    procedure ButtonSaveClick(Sender: TObject);
    procedure ButtonLoadClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormOnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Alakzat_Rajzolasa(X, Y : Integer);
    procedure FormOnMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonVonalClick(Sender: TObject);
    procedure ButtonTeglalapClick(Sender: TObject);
    procedure ButtonKorClick(Sender: TObject);
    procedure ButtonRombuszClick(Sender: TObject);
    procedure EditLineWidthChange(Sender: TObject);
    procedure SavePicToString(); // Elmenti a kpet a rajz String -be
    procedure SavePicToFile(PictureFileName : String);
    procedure Rajz_Betolt(FajlNev : String); // fjlbl
    procedure Rajz_Betolt_Strukturabol(SaveIt : bool); //Struktra Tmbkbl: TVonalTeglalap, TKor, TRombusz
    function Eger_Alakzaton_Rajta_Van(X,Y : Integer) : bool;
    function Eger_Vonalon_Rajta_Van(X, Y, PX, PY, QX, QY, width: Integer): Bool; // P,Q vonalon van-e az XY pont ? {P a startXY, Q a stopXY}
    procedure ButtonKepTorlesClick(Sender: TObject);
    procedure CanvasTorol(); //Ltszlag. Alakzat struktrk (vonalak, teglalapok, korok, rombuszok) maradnak.
    procedure ButtonVisszaRajzolClick(Sender: TObject);
    procedure Felhasznalo_Betolt();

  private
    Program_Started : bool;
    SetColorWidthItem, DeleteItem : TMenuItem; // Jobb egrgombos Pop-Up men
    Exe_Dir : String; // az exe mappja
  public
    felh_adatok : string; //Bekerl majd a FelhAdatok.txt -be
    aktiv_button : string; //Az ppen aktv rajzgomb
    rajz : String; //A rajz string formja
    program_start_time : TDateTime; //Amikor elindult a program (kezdrajz, ha van, betltshez)
    aktiv_alakzat_tipusa : String; aktiv_alakzat_i : Integer; //Ami felett az egr van. Jobb egrgombos funkcikhoz.
    popup_alakzat_tipusa : String; popup_alakzat_i : Integer; // A PopUp pillanatban Jegyzi

    type
    TCustomer = record
      nev : string;
      email  : string;
      szuldat : string;
      cim : string;
      irsz : Integer;
    end;
    var customer : TCustomer;

    type // Vonal s Tglalap ugyanaz a struktra
    TVonalTeglalap = record
      start : TPoint;
      stop  : TPoint;
      width : Integer;
      color : TColor;
      active : bool; //default: false
    end;
    var vonalak : array of TVonalTeglalap;
    var teglalapok : array of TVonalTeglalap;

    type // Kr struktra
    TKor = record
      center : TPoint;
      r  : Integer;
      width : Integer;
      color : TColor;
      active : bool; //default: false
    end;
    var korok : array of TKor;

    type // Rombusz struktra
    TRombusz = record
      center : TPoint;
      f_per_2  : Integer;
      width : Integer;
      color : TColor;
      active : bool; //default: false
    end;
    var rombuszok : array of TRombusz;

  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}
uses FelhAdatok, RajzMentese, RajzBetoltese, SzinSzelessegModositasa;

// CREATE
procedure TForm1.FormCreate(Sender: TObject);
var
  FS : TFileStream;
begin

    Program_Started := True;
    Program_Start_Time := Now; // A FormMouseMove() -ban figyeljk
    Exe_Dir := GetCurrentDir();

    // Title Bar Sznek belltsa
    CustomTitleBar.Control := TitleBarPanel1;
    CustomTitleBar.Enabled := True;
    CustomTitleBar.SystemColors := False;
    CustomTitleBar.SystemButtons := False;
    CustomTitleBar.BackgroundColor := $F0F0F0;
    CustomTitleBar.InactiveBackgroundColor := $F0F0F0;
    CustomTitleBar.ButtonBackgroundColor := $F0F0F0;
    CustomTitleBar.ButtonInactiveBackgroundColor := $F0F0F0;
    CustomTitleBar.ButtonHoverBackgroundColor := $C0C0C0;

    // Canvas Sznek belltsa
    Color := ClWhite;
    Canvas.Pen.Width := StrToInt(EditLineWidth.Text);
    Canvas.Pen.Color := ButtonColor.SymbolColor;
    Canvas.Brush.Style := bsClear; // Transparens objektumok rajzolsa

    if FileExists('FelhAdatok.txt') then // ksbbiekben ide menti a felhaszn. adatokat
      begin
        Felhasznalo_Betolt(); // FelhAdatok.txt -bl
        ShowMessage('Aktulis Felhasznl:' + #13#10#13#10 + felh_adatok);
        ButtonFelhAdatok.Caption := 'Felhasznli Adatok Mdostsa';
      end;
    if not FileExists('torolt_kepernyo.txt') then // ksbbiekben ide menti a trlt kpernyt
      begin
        FS := TFileStream.Create('torolt_kepernyo.txt', fmCreate);
        FreeAndNil(FS);
      end;
      if not FileExists('utolso_allapot.txt') then // ksbbiekben ide menti bezrs utna a kpernyt
      begin
        FS := TFileStream.Create('utolso_allapot.txt', fmCreate);
        FreeAndNil(FS);
      end;
      // EGR MOZGATSA: utolso_allapot.txt BETLTSE (*Form1 Create utn lehet csak betlteni*)

      aktiv_button := 'Vonal'; // Program betltse utn Vonal rajzolhat

      Constraints.MinWidth := 700;
      Constraints.MinHeight := 300;
      SetButtonsLabelsTexts();


   SetColorWidthItem := TMenuItem.Create(PopupMenu1);
   SetColorWidthItem.Caption := 'Szn/Szlessg';
   SetColorWidthItem.OnClick := PopupItemSetColorWidthClick;
   PopupMenu1.Items.Add(SetColorWidthItem);

   DeleteItem := TMenuItem.Create(PopupMenu1);
   DeleteItem.Caption := 'Trls';
   DeleteItem.OnClick := PopupItemDeleteClick;
   PopupMenu1.Items.Add(DeleteItem);

end;

// ALAKZAT MDOSTSA JOBB EGR GOMBBAL
 procedure TForm1.PopupItemSetColorWidthClick(Sender: TObject);
 begin
  FormColorWidthSet.Show;
 end;

 // ALAKZAT TRLSE JOBB EGR GOMBBAL
 procedure TForm1.PopupItemDeleteClick(Sender: TObject);
 begin
    {if MessageDlg('Biztosan trlni szeretn a kvetkez alakzatot?'
                    + #13#10#13#10 + popup_alakzat_tipusa,
    mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then
    begin}
      if popup_alakzat_tipusa = 'Vonal' then
      begin
        Delete(Vonalak,popup_alakzat_i,1);
      end else
      if popup_alakzat_tipusa = 'Tglalap' then
      begin
        Delete(Teglalapok,popup_alakzat_i,1);
      end else
      if popup_alakzat_tipusa = 'Kr' then
      begin
        Delete(Korok,popup_alakzat_i,1);
      end else
      if popup_alakzat_tipusa = 'Rombusz' then
      begin
        Delete(Rombuszok,popup_alakzat_i,1);
      end;

      CanvasTorol();
      Rajz_Betolt_Strukturabol(true); // Ments utolso_allapot.txt -be = True
    {end;}
 end;  

// RESIZE
procedure TForm1.FormOnResize(Sender: TObject);
begin
  SetButtonsLabelsTexts();
  Rajz_Betolt_Strukturabol(false); // Ments nlkl = False
end;

procedure TForm1.SetButtonsLabelsTexts();
begin

  ButtonColor.Left := Form1.Width - ButtonColor.Width - 40;
  EditLineWidth.Left := Form1.Width - EditLineWidth.Width - 30 - (Form1.Width - ButtonColor.Left);
  LabelLineWidth.Left := Form1.Width - LabelLineWidth.Width - 10 - (Form1.Width - EditLineWidth.Left);

  ButtonVisszaRajzol.Left := Form1.Width - ButtonVisszaRajzol.Width - 40;
  ButtonKepTorles.Left := Form1.Width - ButtonKepTorles.Width - 30 - (Form1.Width - ButtonVisszaRajzol.Left);

  ButtonFelhAdatok.Top := Form1.Height - ButtonFelhAdatok.Height - 21;
  ButtonSave.Top := Form1.Height - ButtonSave.Height - 21; 
  ButtonLoad.Top := Form1.Height - ButtonLoad.Height - 21;
  ButtonKepTorles.Top := Form1.Height - ButtonKepTorles.Height - 21; 
  ButtonVisszaRajzol.Top := Form1.Height - ButtonVisszaRajzol.Height - 21;

end;

// GOMBOK
procedure TForm1.ButtonFelhAdatokClick(Sender: TObject);
begin
  if customer.nev <> '' then
  begin
    Form2.EditNev.Text := customer.nev;
    Form2.EditEmail.Text := customer.email;
    Form2.DatePickerSzulDat.Date := StrToDate(StringReplace( customer.szuldat, '.', '/', [ rfReplaceAll ] ));
    Form2.EditCim.Text := customer.cim;
    Form2.EditIrsz.Text := IntToStr(customer.irsz);
  end;
  Form2.Show;
end;

procedure TForm1.ButtonSaveClick(Sender: TObject);
begin
  Form3.Show;
end;

procedure TForm1.ButtonLoadClick(Sender: TObject);
begin
   Form4.Show;
end;

// EGR lENYOMSA
// PUBLIC
var Start : TPoint; // Vonal, Tglalap Rajzolshoz
var Stop : TPoint; // Vonal, Tglalap Rajzolshoz
var Center: TPoint; // Kr, Rombusz Rajzolshoz
var Radius, e_per_2, f_per_2: Integer; // Kr, Rombusz Rajzolshoz
var A, B, C, D : TPoint; // Rombusz pontjai
var elozo_X, elozo_Y : Integer; //elz egr koordinta (a folyamatosa egrmozgshoz)
procedure TForm1.FormOnMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) then
  begin
    Canvas.Pen.Color := ButtonColor.SymbolColor;
    Canvas.Pen.Width := StrToInt(EditLineWidth.Text);

    Start.X := X; // Vonal, Tglalap Rajzolshoz
    Start.Y := Y; // Vonal, Tglalap Rajzolshoz
    Center.X := X; // Kr, Rombusz Rajzolshoz
    Center.Y := Y; // Kr, Rombusz Rajzolshoz

    elozo_X := X;
    elozo_Y := Y;
  end
  else if (Button = mbRight) then
  begin
    if Eger_Alakzaton_Rajta_Van(X,Y) then
    begin
      popup_alakzat_tipusa := aktiv_alakzat_tipusa;
      popup_alakzat_i := aktiv_alakzat_i;
      PopUpMenu1.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
    end;
  end;
end;

// EGR MOZGATSA
// utolso_allapot.txt BETLTSE
// alakzat rajzolsa egr nyomva tartsnl (vonal, tglalap, kr, rombusz)
// nem menti el az alakzatot (felhasznli lmny fokozsa)
procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  Hour,Min,Sec,MSec : word;
  Ellapsed : Integer;
begin

  // utolso_allapot.txt BETLTSE PROGRAM INDTSNL
  if Program_Started = true then
  begin
    DecodeTime(Now-program_start_time,Hour,Min,Sec,MSec);
    Ellapsed := Min * 60000 + Sec * 1000 + MSec;

    if 500 < Ellapsed then
      begin
        Rajz_Betolt('utolso_allapot.txt');
        Canvas.Refresh;
        Program_Started := false;
      end;
  end;

  if (Shift = [ssLeft]) then
  begin

    // alakzat rajzolsa egr nyomva tartsnl (vonal, tglalap, kr, rombusz)
    Canvas.Pen.Color := CLwhite;
    Alakzat_Rajzolasa(elozo_X,elozo_Y); //X,Y az egr mozgatsval vals idben frissl
    Canvas.Pen.Color := ButtonColor.SymbolColor;
    Alakzat_Rajzolasa(X,Y); //X,Y az egr mozgatsval vals idben frissl

    elozo_X := X;
    elozo_Y := Y;

  end;

  // tvlt az egr, amikor
  // az alakzat fel visszk VAGY ppen rajzolunk
  if Eger_Alakzaton_Rajta_Van(X,Y) or (Shift = [ssLeft]) then
    Screen.Cursor := crCross
  else
    Screen.Cursor := crDefault;

end;

procedure TForm1.Alakzat_Rajzolasa(X,Y : Integer);
begin
    if aktiv_button = 'Vonal' then
    begin
      Canvas.MoveTo(Start.X,Start.Y);
      Canvas.LineTo(X,Y);
    end
    else if aktiv_button = 'Tglalap' then
      begin
        Canvas.Rectangle(Start.X, Start.Y, X, Y);
      end
      else if aktiv_button = 'Kr' then
        begin
          Radius := Round (  // Kr, Rombusz Rajzolshoz
                    Sqrt(
                      Sqr( abs(X - Start.X) )
                      +  // c := Sqrt ( Sqr(a) + Sqr(b) ) {a2+b2=c2}
                      Sqr( abs(Y - Start.Y) )
                      )
                  ); // Kr, Rombusz Rajzolshoz
          Canvas.Ellipse(Center.X-Radius, Center.Y-Radius, Center.X+Radius, Center.Y+Radius);
        end
        else if aktiv_button = 'Rombusz' then
          begin
            f_per_2 := abs(X - Start.X);
            e_per_2 := Round(f_per_2 * Cotan(DegToRad(53.1 / 2)));

            A.X := Center.X; A.Y := Center.Y - e_per_2;
            B.X := Center.X + f_per_2; B.Y := Center.Y;
            C.X := Center.X; C.Y := Center.Y + e_per_2;
            D.Y := Center.Y; D.X := Center.X - f_per_2;
            Canvas.Polygon([A,B,C,D]);
          end;
end;


// EGR FELENGEDSE
procedure TForm1.FormOnMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
  begin

    Stop.X := X; // Vonal, Tglalap Rajzolshoz
    Stop.Y := Y; // Vonal, Tglalap Rajzolshoz

    Alakzat_Rajzolasa(Stop.X,Stop.Y);

    //+ Alakzat_Mentse
    if aktiv_button = 'Vonal' then
    begin

      SetLength(vonalak, Length(vonalak)+1);
      vonalak[Length(vonalak) - 1].start.X := Start.X;
      vonalak[Length(vonalak) - 1].start.Y := Start.Y;
      vonalak[Length(vonalak) - 1].stop.X := Stop.X;
      vonalak[Length(vonalak) - 1].stop.Y := Stop.Y;
      vonalak[Length(vonalak) - 1].width := StrToInt(EditLineWidth.Text);
      vonalak[Length(vonalak) - 1].color := ButtonColor.SymbolColor;

    end else
      if aktiv_button = 'Tglalap' then
      begin

        SetLength(teglalapok, Length(teglalapok)+1);
        teglalapok[Length(teglalapok) - 1].start.X := Start.X;
        teglalapok[Length(teglalapok) - 1].start.Y := Start.Y;
        teglalapok[Length(teglalapok) - 1].stop.X := Stop.X;
        teglalapok[Length(teglalapok) - 1].stop.Y := Stop.Y;
        teglalapok[Length(teglalapok) - 1].width := StrToInt(EditLineWidth.Text);
        teglalapok[Length(teglalapok) - 1].color := ButtonColor.SymbolColor;

      end else
        if aktiv_button = 'Kr' then
        begin
          Radius := Round (  // Kr, Rombusz Rajzolshoz
                      Sqrt(
                        Sqr( abs(Stop.X - Start.X) )
                        +  // c := Sqrt ( Sqr(a) + Sqr(b) ) {a2+b2=c2}
                        Sqr( abs(Stop.Y - Start.Y) )
                        )
                    ); // Kr, Rombusz Rajzolshoz

          SetLength(korok, Length(korok)+1);
          korok[Length(korok) - 1].center.X := Center.X;
          korok[Length(korok) - 1].center.Y := Center.Y;
          korok[Length(korok) - 1].r := Radius;
          korok[Length(korok) - 1].width := StrToInt(EditLineWidth.Text);
          korok[Length(korok) - 1].color := ButtonColor.SymbolColor;

        end else
            if aktiv_button = 'Rombusz' then
            begin

              f_per_2 := abs(Stop.X - Start.X);

              SetLength(rombuszok, Length(rombuszok)+1);
              rombuszok[Length(rombuszok) - 1].center.X := Center.X;
              rombuszok[Length(rombuszok) - 1].center.Y := Center.Y;
              rombuszok[Length(rombuszok) - 1].f_per_2 := f_per_2;
              rombuszok[Length(rombuszok) - 1].width := StrToInt(EditLineWidth.Text);
              rombuszok[Length(rombuszok) - 1].color := ButtonColor.SymbolColor;

            end;

  Rajz_Betolt_Strukturabol(true); //ments utolso_allapot.txt -be

  end;

end;

// ALAKZAT GOMBOK
procedure TForm1.ButtonVonalClick(Sender: TObject);
begin
  aktiv_button := 'Vonal';
  caption := 'Rajz Program - Aktv: ' + aktiv_button + ' rajzols';
end;

procedure TForm1.ButtonTeglalapClick(Sender: TObject);
begin
  aktiv_button := 'Tglalap';
  caption := 'Rajz Program - Aktv: ' + aktiv_button + ' rajzols';
end;

procedure TForm1.ButtonKorClick(Sender: TObject);
begin
    aktiv_button := 'Kr';
  caption := 'Rajz Program - Aktv: ' + aktiv_button + ' rajzols';
end;

procedure TForm1.ButtonRombuszClick(Sender: TObject);
begin
  aktiv_button := 'Rombusz';
  caption := 'Rajz Program - Aktv: ' + aktiv_button + ' rajzols';
end;

procedure TForm1.EditLineWidthChange(Sender: TObject);
var
  v: integer;
begin
  if not TryStrToInt(EditLineWidth.Text, v) then begin
     EditLineWidth.Text  := '3';     // default value
     EditLineWidth.Color := clRed;   // piros httr
  end else
    begin
      EditLineWidth.Color := clWindow; // fehr httr
      if EditLineWidth.Text = '0' then
      begin
        EditLineWidth.Text := '1'
      end;
    end;
end;

// FELADAT Specifikus Funkcik
procedure TForm1.SavePicToString(); // Elmenti a kpet a Form1.rajz Stringbe
var
  i : Integer;
begin
  rajz := '';

  for i := 0 to Length(Vonalak)-1 do
  begin
    rajz := rajz + 'V ' + IntToStr(Vonalak[i].start.X) + ' ' + IntToStr(Vonalak[i].start.Y)
    + ' ' + IntToStr(Vonalak[i].stop.X) + ' ' + IntToStr(Vonalak[i].stop.Y)
    + ' ' + ColorToString(Vonalak[i].color) + ' ' + IntToStr(Vonalak[i].width) + #13#10;
  end;
  for i := 0 to Length(Teglalapok)-1 do
  begin
    rajz := rajz + 'T ' + IntToStr(Teglalapok[i].start.X) + ' ' + IntToStr(Teglalapok[i].start.Y)
    + ' ' + IntToStr(Teglalapok[i].stop.X) + ' ' + IntToStr(Teglalapok[i].stop.Y)
    + ' ' + ColorToString(Teglalapok[i].color) + ' ' + IntToStr(Teglalapok[i].width) + #13#10;
  end;
  for i := 0 to Length(Korok)-1 do
  begin
    rajz := rajz + 'K ' + IntToStr(Korok[i].center.X) + ' ' + IntToStr(Korok[i].center.Y)
    + ' ' + IntToStr(Korok[i].r)
    + ' ' + ColorToString(Korok[i].color) + ' ' + IntToStr(Korok[i].width) + #13#10;
  end;
  for i := 0 to Length(Rombuszok)-1 do
  begin
    rajz := rajz + 'R ' + IntToStr(Rombuszok[i].center.X) + ' ' + IntToStr(Rombuszok[i].center.Y)
    + ' ' + IntToStr(Rombuszok[i].f_per_2)
    + ' ' + ColorToString(Rombuszok[i].color) + ' ' + IntToStr(Rombuszok[i].width) + #13#10;
  end;

end;

procedure TForm1.SavePicToFile(PictureFileName : String);
var
  FileToSave_Picture : TextFile;
  FS : TFileStream;
begin

  felh_adatok :=   customer.nev + #13#10 +
                    customer.email + #13#10 +
                    customer.szuldat + #13#10 +
                    customer.cim + #13#10 +
                    IntToStr(customer.irsz);

  SavePicToString(); // Elmenti a kpet a Form1.rajz Stringbe

  if not FileExists(PictureFileName) then
      begin
          FS := TFileStream.Create(PictureFileName, fmCreate);
          FreeAndNil(FS);
      end;

  AssignFile(FileToSave_Picture, PictureFileName);
  ReWrite(FileToSave_Picture);
  Write(FileToSave_Picture, felh_adatok + #13#10#13#10);
  Write(FileToSave_Picture, rajz);
  CloseFile(FileToSave_Picture);

  ChDir(Exe_Dir); // Visszamegynk az EXE mappjba, hogy ksbb ne ssze-vissza mentse a fjlokat

end;

// FJLBL RAJZOLS
procedure TForm1.Rajz_Betolt(FajlNev : String);
var
  RajzFile : TextFile;
  input_line : String;
  List : TStrings;
  i : Integer;
begin

    if FileExists(FajlNev) then
      begin
        vonalak := nil;
        teglalapok := nil;
        korok := nil;
        rombuszok := nil;

        AssignFile(RajzFile,FajlNev);
        Reset(RajzFile);
        for i := 1 to 6 do
          ReadLn(RajzFile, input_line); // A 7. sortl jn a rajz (1-6 mindig felhasznli adat)

        while not Eof(RajzFile) do
        begin
          ReadLn(RajzFile, input_line);

          Try
          CanvasTorol();
          Case input_line[ Length(input_line)-Length(input_line)+1 {= 0. index} ] of
           'V' :
              begin
                List := TStringList.Create;
                ExtractStrings([' '], [], PChar(input_line), List);
                SetLength(vonalak, Length(vonalak)+1);
                Vonalak[Length(vonalak)-1].start.X := StrToInt(List[1]);
                Vonalak[Length(vonalak)-1].start.Y := StrToInt(List[2]);
                Vonalak[Length(vonalak)-1].stop.X := StrToInt(List[3]);
                Vonalak[Length(vonalak)-1].stop.Y := StrToInt(List[4]);
                Vonalak[Length(vonalak)-1].color := StringToColor(List[5]);
                Vonalak[Length(vonalak)-1].width := StrToInt(List[6]);
                List.Free;
              end;
           'T' :
              begin
                List := TStringList.Create;
                ExtractStrings([' '], [], PChar(input_line), List);
                SetLength(teglalapok, Length(teglalapok)+1);
                Teglalapok[Length(teglalapok)-1].start.X := StrToInt(List[1]);
                Teglalapok[Length(teglalapok)-1].start.Y := StrToInt(List[2]);
                Teglalapok[Length(teglalapok)-1].stop.X := StrToInt(List[3]);
                Teglalapok[Length(teglalapok)-1].stop.Y := StrToInt(List[4]);
                Teglalapok[Length(teglalapok)-1].color := StringToColor(List[5]);
                Teglalapok[Length(teglalapok)-1].width := StrToInt(List[6]);
                List.Free;
              end;
           'K' :
              begin
                List := TStringList.Create;
                ExtractStrings([' '], [], PChar(input_line), List);
                SetLength(korok, Length(korok)+1);
                Korok[Length(korok)-1].center.X := StrToInt(List[1]);
                Korok[Length(korok)-1].center.Y := StrToInt(List[2]);
                Korok[Length(korok)-1].r := StrToInt(List[3]);
                Korok[Length(korok)-1].color := StringToColor(List[4]);
                Korok[Length(korok)-1].width := StrToInt(List[5]);
                List.Free;
              end;
           'R' :
              begin
                List := TStringList.Create;
                ExtractStrings([' '], [], PChar(input_line), List);
                SetLength(rombuszok, Length(rombuszok)+1);
                Rombuszok[Length(rombuszok)-1].center.X := StrToInt(List[1]);
                Rombuszok[Length(rombuszok)-1].center.Y := StrToInt(List[2]);
                Rombuszok[Length(rombuszok)-1].f_per_2 := StrToInt(List[3]);
                Rombuszok[Length(rombuszok)-1].color := StringToColor(List[4]);
                Rombuszok[Length(rombuszok)-1].width := StrToInt(List[5]);
                List.Free;
              end;
          else
            input_line := '';
          end
          Except
            ShowMessage('A ' + FajlNev + ' a programmal nem kompatibilis .');
          end;

        end;

        CloseFile(RajzFile);
        Rajz_Betolt_Strukturabol(true); // Menti az utolso_allapot.txt -be = true

      end else
        ShowMessage('A ' + FajlNev + ' nem ltezik.');

      ChDir(Exe_Dir); // Visszamegynk az EXE mappjba, hogy ksbb ne ssze-vissza mentse a fjlokat

end;

// ALAKZAT STRUKTRKBL RAJZOLS
procedure TForm1.Rajz_Betolt_Strukturabol(SaveIt : bool);
var
  i : Integer;
begin

    for i := 0 to Length(Vonalak)-1 do
    begin
      Canvas.Pen.Color := Vonalak[i].color;
      Canvas.Pen.Width := Vonalak[i].width;
      Canvas.MoveTo(Vonalak[i].start.X,Vonalak[i].start.Y);
      Canvas.LineTo(Vonalak[i].stop.X,Vonalak[i].stop.Y);
    end;

    for i := 0 to Length(Teglalapok)-1 do
    begin
      Canvas.Pen.Color := Teglalapok[i].color;
      Canvas.Pen.Width := Teglalapok[i].width;
      Canvas.Rectangle(Teglalapok[i].start.X, Teglalapok[i].start.Y, Teglalapok[i].stop.X, Teglalapok[i].stop.Y);
    end;

    for i := 0 to Length(Korok)-1 do
    begin
      Canvas.Pen.Color := Korok[i].color;
      Canvas.Pen.Width := Korok[i].width;
      Canvas.Ellipse(Korok[i].center.X-Korok[i].r, Korok[i].center.Y-Korok[i].r, Korok[i].center.X+Korok[i].r, Korok[i].center.Y+Korok[i].r);
    end;

    for i := 0 to Length(Rombuszok)-1 do
    begin
      Canvas.Pen.Color := Rombuszok[i].color;
      Canvas.Pen.Width := Rombuszok[i].width;

      f_per_2 := Rombuszok[i].f_per_2;
      e_per_2 := Round(f_per_2 * Cotan(DegToRad(53.1 / 2)));

      A.X := Rombuszok[i].center.X; A.Y := Rombuszok[i].center.Y - e_per_2;
      B.X := Rombuszok[i].center.X + f_per_2; B.Y := Rombuszok[i].center.Y;
      C.X := Rombuszok[i].center.X; C.Y := Rombuszok[i].center.Y + e_per_2;
      D.Y := Rombuszok[i].center.Y; D.X := Rombuszok[i].center.X - f_per_2;
      Canvas.Polygon([A,B,C,D]);
    end;

    //Ha kell, mentjk a Canvas -ra betlttt struktrt az utolso_allapot.txt -be
    if SaveIt = True then
    begin
      ChDir(Exe_Dir); // Visszamegynk az EXE mappjba
      SavePicToFile('utolso_allapot.txt');
    end;

end;

function TForm1.Eger_Alakzaton_Rajta_Van(X,Y : Integer) : bool;
var
  i : Integer;
  prox: Integer; // kozelites
  e_per_2: Integer; A,B,C,D : TPoint; // Rombuszhoz
begin
  Eger_Alakzaton_Rajta_Van := false;

  for i := 0 to Length(Vonalak)-1 do
  begin
    if 3 < Vonalak[i].width then prox := Vonalak[i].width else prox := 3;
  
    if Eger_Vonalon_Rajta_Van(
        X,Y,
        Vonalak[i].start.X,Vonalak[i].start.Y,
        Vonalak[i].stop.X,Vonalak[i].stop.Y,
        prox
        ) then
    begin
      Eger_Alakzaton_Rajta_Van := true;
      aktiv_alakzat_tipusa := 'Vonal';
      aktiv_alakzat_i := i;
      Vonalak[i].Active := true; // Ha felette az egr, aktv
    end else Vonalak[i].Active := false; // Egybknt inaktv 
  end;
  for i := 0 to Length(Teglalapok)-1 do
  begin

    if 3 < Teglalapok[i].width then prox := Teglalapok[i].width else prox := 3;

    A.X := Teglalapok[i].start.X;
    A.Y := Teglalapok[i].start.Y;
    B.X := Teglalapok[i].stop.X;
    B.Y := Teglalapok[i].start.Y;
    C.X := Teglalapok[i].stop.X;
    C.Y := Teglalapok[i].stop.Y;
    D.X := Teglalapok[i].start.X;
    D.Y := Teglalapok[i].stop.Y;

    //AB -n rajta van-e ?
    if Eger_Vonalon_Rajta_Van(X,Y,A.X,A.Y,B.X,B.Y,prox) or
    //BC -n rajta van-e ?
       Eger_Vonalon_Rajta_Van(X,Y,B.X,B.Y,C.X,C.Y,prox) or
    //CD -n rajta van-e ?
        Eger_Vonalon_Rajta_Van(X,Y,C.X,C.Y,D.X,D.Y,prox) or
    //DA -n rajta van-e ?
        Eger_Vonalon_Rajta_Van(X,Y,D.X,D.Y,A.X,A.Y,prox)
    then
    begin
      Eger_Alakzaton_Rajta_Van := true;
      aktiv_alakzat_tipusa := 'Tglalap';
      aktiv_alakzat_i := i;
      Teglalapok[i].Active := true; // Ha felette az egr, aktv
    end else Teglalapok[i].Active := false; // Egybknt inaktv

  end;
  for i := 0 to Length(Korok)-1 do
  begin

    if 3 < Korok[i].width then prox := Korok[i].width else prox := 3;

    // Pitagorasz ttellel
    if ((Korok[i].r + prox) > sqrt( sqr(abs(X-Korok[i].center.X)) + sqr(abs(Y-Korok[i].center.Y)) ))
        and
       ((Korok[i].r - prox) < sqrt( sqr(abs(X-Korok[i].center.X)) + sqr(abs(Y-Korok[i].center.Y)) ))
       then
    begin
      Eger_Alakzaton_Rajta_Van := true;
      aktiv_alakzat_tipusa := 'Kr';
      aktiv_alakzat_i := i;
      Korok[i].Active := true; // Ha felette az egr, aktv
    end else Korok[i].Active := false; // Egybknt inaktv

  end;
  for i := 0 to Length(Rombuszok)-1 do
  begin
    if 3 < Rombuszok[i].width then prox := Rombuszok[i].width else prox := 3;
  
    f_per_2 := Rombuszok[i].f_per_2;
    e_per_2 := Round(f_per_2 * Cotan(DegToRad(53.1 / 2)));

    A.X := Rombuszok[i].center.X; A.Y := Rombuszok[i].center.Y - e_per_2;
    B.X := Rombuszok[i].center.X + f_per_2; B.Y := Rombuszok[i].center.Y;
    C.X := Rombuszok[i].center.X; C.Y := Rombuszok[i].center.Y + e_per_2;
    D.Y := Rombuszok[i].center.Y; D.X := Rombuszok[i].center.X - f_per_2;

    //AB -n rajta van-e ?
    if Eger_Vonalon_Rajta_Van(
        X,Y,
        A.X,A.Y,
        B.X,B.Y,
        prox
        ) or
    //BC -n rajta van-e ?
       Eger_Vonalon_Rajta_Van(
        X,Y,
        B.X,B.Y,
        C.X,C.Y,
        prox
        ) or
    //CD -n rajta van-e ?
        Eger_Vonalon_Rajta_Van(
        X,Y,
        C.X,C.Y,
        D.X,D.Y,
        prox
        ) or
    //DA -n rajta van-e ?
        Eger_Vonalon_Rajta_Van(
        X,Y,
        D.X,D.Y,
        A.X,A.Y,
        prox
        )
    then
    begin
      Eger_Alakzaton_Rajta_Van := true;
      aktiv_alakzat_tipusa := 'Rombusz';
      aktiv_alakzat_i := i;
      Rombuszok[i].Active := true; // Ha felette az egr, aktv
    end else Rombuszok[i].Active := false; // Egybknt inaktv
  
  end;

end;

// P,Q vonalon van-e az XY pont ? {P a startXY, Q a stopXY}
function TForm1.Eger_Vonalon_Rajta_Van(X, Y, PX, PY, QX, QY, width: Integer): Bool;
var
  sinus,cosinus : Double;
  width_X,width_Y,length : Integer;
begin

  asm
    fild(QY)  // QY trolsa regiszterben
    fisub(PY) // Y-Klnbsg: QY - PY trolsa ugyanabban a regiszterben
    fild(QX)  // QX trolsa regiszterben
    fisub(PX) // X-Klnbsg: QX - PX trolsa ugyanabban a regiszterben
    fpatan    // Vonal szgnek kiszmtsa tangens alapjn, st(0) regiszterbe trolva
    fsincos   // Sinus trolsa st(0)-ban, Cosinus trolsa st(1)-ben
    fstp cosinus // st(1) regiszter rtkt megkapja cosinus : Double
    fstp sinus // st(0) regiszter rtkt megkapja sinus : Double 
  end;
  
  width_X  := Round(cosinus * (X - PX) + sinus * (Y - PY));
  width_Y  := Round(cosinus * (Y - PY) - sinus * (X - PX));
  length := Round(cosinus * (QX - PX) + sinus * (QY - PY)); // Vonal hossza
  
  if
    (width_Y > -width) and (width_Y < width) and (width_X > -width) and (width_X < length + width)
  then 
    Result := True
  else 
    Result := False;
    
end;

//TRLS GOMB
procedure TForm1.ButtonKepTorlesClick(Sender: TObject); //Kp Trlse funkci
begin

  ChDir(Exe_Dir); // Visszamegynk az EXE mappjba
  SavePicToFile('torolt_kepernyo.txt'); // a kitrlt kp, amit vissza lehet lltani
  CanvasTorol();

  vonalak := nil;
  teglalapok := nil;
  korok := nil;
  rombuszok := nil;

  SavePicToFile('utolso_allapot.txt'); // az utols llapot egy res kperny lesz

end;

procedure TForm1.CanvasTorol(); //Ltszlag. Alakzat struktrk maradnak.
begin
  Canvas.Brush.Style := bsSolid; // Transzparencia kikapcsolsa
  Canvas.brush.color:=clwhite;
  Canvas.Pen.Color := clwhite;

  Canvas.rectangle(clientrect); //Rajzol a Form1 -re egy fehr tglalapot

  Canvas.Pen.Color := ButtonColor.SymbolColor; //Szn visszalltsa
  Canvas.Brush.Style := bsClear; // Transzparencia bekapcsolsa
end;

//VISSZALLTS GOMB
procedure TForm1.ButtonVisszaRajzolClick(Sender: TObject);
begin
  ChDir(Exe_Dir); // Visszamegynk az EXE mappjba
  Rajz_Betolt('torolt_kepernyo.txt');
end;

procedure TForm1.Felhasznalo_Betolt();
var
  CustomerFile : TextFile;
begin
  ChDir(Exe_Dir); // Visszamegynk az EXE mappjba
  if FileExists('FelhAdatok.txt') then
    begin
      AssignFile(CustomerFile, 'FelhAdatok.txt');
      Reset(CustomerFile);
      ReadLn(CustomerFile, customer.nev);
      ReadLn(CustomerFile, customer.email);
      ReadLn(CustomerFile, customer.szuldat);
      ReadLn(CustomerFile, customer.cim);
      ReadLn(CustomerFile, customer.irsz);
      felh_adatok :=      customer.nev + #13#10 +
                  customer.email + #13#10 +
                  customer.szuldat + #13#10 +
                  customer.cim + #13#10 +
                  IntToStr(customer.irsz);
      CloseFile(CustomerFile);
    end;
end;

end.
